# This file was generated by Rcpp::compileAttributes
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

floyd <- function(data) {
    .Call('KODAMA_floyd', PACKAGE = 'KODAMA', data)
}

knn.kodama <- function(Xtrain, Ytrain, Xtest, k){
    Xtrain=as.matrix(Xtrain)
    Xtest=as.matrix(Xtest)
    if(is.factor(Ytrain)){
      lev=levels(Ytrain)
      Ytrain=as.matrix(as.numeric(Ytrain))
      o=.Call('KODAMA_knn_kodama_c', PACKAGE = 'KODAMA', Xtrain, Ytrain, Xtest, k)
      o=matrix(as.vector(factor(lev[o],levels=lev)),ncol=k)
    }else{
      Ytrain=as.matrix(Ytrain)
      o=.Call('KODAMA_knn_kodama_r', PACKAGE = 'KODAMA', Xtrain, Ytrain, Xtest, k)
    }
    o
}

samm_cpp <- function(x, y, k) {
    .Call('KODAMA_samm_cpp', PACKAGE = 'KODAMA', x, y, k)
}

KNNCV <- function(x, cl, constrain, k) {
    .Call('KODAMA_KNNCV', PACKAGE = 'KODAMA', x, cl, constrain, k)
}

transformy <- function(y) {
    .Call('KODAMA_transformy', PACKAGE = 'KODAMA', y)
}

PLSDACV <- function(x, cl, constrain, k) {
    .Call('KODAMA_PLSDACV', PACKAGE = 'KODAMA', x, cl, constrain, k)
}

pls.kodama <- function(Xtrain, Ytrain, Xtest, ncomp) {
  Xtrain=as.matrix(Xtrain)
  Xtest=as.matrix(Xtest)
  nr=nrow(Xtest)
  if(is.factor(Ytrain)){
    lev=levels(Ytrain)
    Ytrain=transformy(Ytrain)
    o=.Call('KODAMA_pls_kodama', PACKAGE = 'KODAMA', Xtrain, Ytrain, Xtest, ncomp)
    Ypred=matrix(nrow=nr,ncol=ncomp)
    for(i in 1:ncomp){
      t=apply(o$Ypred[,,i],1,which.max)
      Ypred[,i]=as.vector(factor(lev[t],levels=lev))
    }
    o$Ypred=Ypred
  }else{
    Ytrain=as.matrix(Ytrain)
    o=.Call('KODAMA_pls_kodama', PACKAGE = 'KODAMA', Xtrain, Ytrain, Xtest, ncomp)
    Ypred=matrix(nrow=nr,ncol=ncomp)
    for(i in 1:ncomp){
      Ypred[,i]=o$Ypred[,,i]
    }
    o$Ypred=Ypred
  }
  o
}



unic <- function(x) {
    .Call('KODAMA_unic', PACKAGE = 'KODAMA', x)
}

optim_pls_cv <- function(x, clmatrix, constrain, ncomp) {
  .Call('KODAMA_optim_pls_cv', PACKAGE = 'KODAMA', x, clmatrix, constrain, ncomp)
}

optim_knn_r_cv <- function(x, clmatrix, constrain, ncomp) {
  .Call('KODAMA_optim_knn_r_cv', PACKAGE = 'KODAMA', x, clmatrix, constrain, ncomp)
}

optim_knn_C_cv <- function(x, clmatrix, constrain, ncomp) {
  .Call('KODAMA_optim_knn_c_cv', PACKAGE = 'KODAMA', x, clmatrix, constrain, ncomp)
}

double_pls_cv <- function(x, y, constrain, type, verbose, compmax) {
  .Call('KODAMA_double_pls_cv', PACKAGE = 'KODAMA', x, y, constrain, type, verbose, compmax)
}

double_knn_cv <- function(x, yy, constrain, type, verbose, compmax) {
  .Call('KODAMA_double_knn_cv', PACKAGE = 'KODAMA', x, yy, constrain, type, verbose, compmax)
}

fit_pls <- function(x, y, type) {
    .Call('KODAMA_fit_pls', PACKAGE = 'KODAMA', x, y, type)
}

corecpp <- function(x, xTdata, clbest, Tcycle, FUN, fpar, constrain, fix, shake, proj) {
    .Call('KODAMA_corecpp', PACKAGE = 'KODAMA', x, xTdata, clbest, Tcycle, FUN, fpar, constrain, fix, shake, proj)
}

another <- function(pptrain, xtrain, xtest, res, Xlink, epsilon) {
    .Call('KODAMA_another', PACKAGE = 'KODAMA', pptrain, xtrain, xtest, res, Xlink, epsilon)
}

